> For the complete documentation index, see [llms.txt](https://docs.ionprotocol.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionprotocol.io/devs/smart-contract-architecture/libraries/lrt/kelpdaolibrary.md).

# KelpDaoLibrary

[Git Source](https://github.com/Ion-Protocol/ion-protocol/blob/88cc595825f1dc2eb738fb93e172a3e8ab7a5c43/src/libraries/lrt/KelpDaoLibrary.sol)

A helper library for KelpDao-related conversions.

### [Functions](broken://pages/1C6cPV7LsVzxSm4G79Ql) <a href="#functions" id="functions"></a>

#### [depositForLrt](broken://pages/1C6cPV7LsVzxSm4G79Ql) <a href="#depositforlrt" id="depositforlrt"></a>

Deposits a given amount of ETH into the rsETH Deposit Pool.

*Care should be taken to handle slippage in the calling function since this function sets NO slippage controls.*

```
function depositForLrt(IRsEth, uint256 ethAmount) internal returns (uint256 rsEthAmountToMint);
```

**Parameters**

| Name        | Type      | Description                      |
| ----------- | --------- | -------------------------------- |
| `<none>`    | `IRsEth`  |                                  |
| `ethAmount` | `uint256` | Amount of ETH to deposit. \[WAD] |

**Returns**

| Name                | Type      | Description                               |
| ------------------- | --------- | ----------------------------------------- |
| `rsEthAmountToMint` | `uint256` | Amount of rsETH that was obtained. \[WAD] |

#### [getEthAmountInForLstAmountOut](broken://pages/1C6cPV7LsVzxSm4G79Ql) <a href="#getethamountinforlstamountout" id="getethamountinforlstamountout"></a>

Returns the amount of ETH required to mint a given amount of rsETH.

```
function getEthAmountInForLstAmountOut(IRsEth, uint256 amountOut) internal view returns (uint256);
```

**Parameters**

| Name        | Type      | Description                    |
| ----------- | --------- | ------------------------------ |
| `<none>`    | `IRsEth`  |                                |
| `amountOut` | `uint256` | Desired output amount of rsETH |

#### [getLstAmountOutForEthAmountIn](broken://pages/1C6cPV7LsVzxSm4G79Ql) <a href="#getlstamountoutforethamountin" id="getlstamountoutforethamountin"></a>

Calculates the amount of rsETH that will be minted for a given amount of ETH.

```
function getLstAmountOutForEthAmountIn(IRsEth, uint256 ethAmount) internal view returns (uint256);
```

**Parameters**

| Name        | Type      | Description                        |
| ----------- | --------- | ---------------------------------- |
| `<none>`    | `IRsEth`  |                                    |
| `ethAmount` | `uint256` | Amount of ETH to use to mint rsETH |

**Returns**

| Name     | Type      | Description                                         |
| -------- | --------- | --------------------------------------------------- |
| `<none>` | `uint256` | Amount of outputted rsETH for a given amount of ETH |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ionprotocol.io/devs/smart-contract-architecture/libraries/lrt/kelpdaolibrary.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
